// ========================== TEXT INTERFACE ======================== //
// Type: document				 							   //
// =================================================================== //

#ifndef _IDOCUMENT_
#define _IDOCUMENT_

#include <map>
#include <string>
#include <vector>

#include <string>
#include <gtk/gtk.h>

#include <pthread.h>

#include "gloobus-preview-interface-main.h"


using namespace std;

class iDocument : public interface
{
	protected:
  	
 	vector<GtkWidget*> 		m_widget_pages;
 	GtkWidget*				m_scwin;				//Scolled window to store the document pages
 	GtkAdjustment* 			m_hadj;					//To move the horizontal scroll
 	GtkWidget*				m_vBox;					//Vertical Box to put the pages
	bool					m_destroyed;
	pthread_t 				m_thread;

	public:
				//Virtual Functions implemented from interface
				virtual int 	get_width	( void );
				virtual int 	get_height	( void );
				virtual	void	draw		( GtkContainer * container );
				virtual void	load		( void );
				virtual void	end			( void );

				void			load2		( void);
				float			get_scale   ( int x, int y );
				void			draw_doc	 	(GtkContainer * container); 
				void 			draw_file_info	(GtkContainer * container);

				
		//These next virtual functions musth be implemented for iDocument plugins
		virtual	int				get_n_pages		( void )  		= 0;		
		virtual int				get_page_width  ( void )  		= 0;
		virtual int				get_page_height ( void )  		= 0;
		virtual GdkPixbuf*		get_page_pixbuf ( int page )  	= 0;
		virtual	void			end_plugin 		( void ) 		= 0;
		
								~iDocument();

	private:
};


//==============  CLASS FACTORIES DEFINITIONS================================= //
typedef iDocument* create_t_document ();									    //CREATE PLUGIN
typedef void destroy_t_document  (iDocument*);							   		//DESTROY PLUGIN
	
extern map<string, create_t_document *, less<string> > factory_document;		   //MAP WITH NAME AND CONSTRUCTOR
extern map<string, destroy_t_document *, less<string> > factoryDestroy_document;   //MAP WITH NAME AND DESTRUCTOR
extern vector<plugin_filetype> pluginVector;				   		 	  		   //VECTOR TO STORE WICH FILETYPE READ EACH PLUGIN


#endif
