#include "gloobus-preview-plugin-manager.h"

pluginManager::pluginManager(){}	
pluginManager::~pluginManager(){}
//============================== SET FILENAME =========================== //
void pluginManager::get_info(string filename)
{
	GFile *  m_gfile = g_file_new_for_path (filename.c_str () );
	GFileInfo * info = g_file_info_new	 ();
	info 			 = g_file_query_info ( m_gfile,  "standard::content-type" ,G_FILE_QUERY_INFO_NONE, NULL , NULL);
	m_filetype 		 = g_file_info_get_attribute_string ( info, "standard::content-type" );

}
// ============================= LOAD PLUGINS ============================ //
void pluginManager::load_plugins()
{
	static unsigned int BUF_SIZE = 1024;
    void *dlib;					// Plugin Handel
	FILE *dl;					// File Handle
	char in_buf[BUF_SIZE]; 		// input buffer for lib
    char name[1024]; 


	// == Read Directory == //
	string cmd = "ls " + (string)PACKAGE_LIB_PATH + "/*.so";
 	dl = popen(cmd.c_str(), "r");		//List all plugins (*.so);
   	if(!dl){      
		perror("popen");      
		exit(-1);   	
	}

	// == Load Plugins == //
	//TODO: If there are errors, don't load the plugin that gives error
	g_debug("\033[1;37mLOADING PLUGINS\033[1;m\n");
	while(fgets(in_buf, BUF_SIZE, dl))
	{
		char *ws = strpbrk(in_buf, " \t\n");	// trim off the whitespace
		if(ws) *ws = '\0';
		sprintf(name, "%s", in_buf);	      	// append ./ to the front of the lib name
		g_debug("\t %s\n",name);			

		dlib = dlopen(name, RTLD_NOW);			// Load Plugin
		if(dlib == NULL){
			g_critical("Error loading Plugin: %s\n", dlerror());
			exit(-1);
		}
		
		// == See if versions match == //
		getVersion_t* get_version=(getVersion_t*) dlsym(dlib,"getVersion");
		if(get_version() != MANAGER_VERSION)
		{
			g_critical("error: the plugin doesn't match the manager version\n");
			exit(-1);
		}
		m_dl_list.insert(m_dl_list.end(), dlib);	// add the handle to our list
	}
	fclose(dl);
}

// ============================= UNLOAD PLUGINS ========================== //
void pluginManager::unload_plugins()
{
	for(m_itr=m_dl_list.begin(); m_itr!=m_dl_list.end(); m_itr++)
	{
		dlclose(*m_itr);
	}
}
// ============================= GET CLASS TYPE ========================= //
string pluginManager::get_classtype()
{
	return m_classtype;
}

// ============================= SEARCH FOR PLUGIN ========================= //
string pluginManager::search_for_plugin(string filename)
{
	m_classtype = "";
	string temp  = "";
	int priority = 0;
	get_info ( filename );
	
  	printf("Mime Type: %s\n",m_filetype.c_str());
	string mime = m_filetype;
	mime = mime.substr(0,mime.find(";"));
	mime = mime.substr(0,mime.find(","));
  	
	for(unsigned int i=0; i<pluginVector.size(); i++)
	{
		//printf("%s - %s\n",mime.c_str(),pluginVector[i].filetype.c_str());
		if(mime == pluginVector[i].filetype)
		{
			if(temp == "")											//The first
			{	
				temp 	 = pluginVector[i].name;			
				priority = pluginVector[i].priority;
				m_classtype = pluginVector[i].type;
			}
			if(temp != "" && pluginVector[i].priority > priority)	//There is another found.. look for priority
			{
				temp = pluginVector[i].name;
				priority = pluginVector[i].priority;
				m_classtype = pluginVector[i].type;
			}
		}
	}
	return temp;
}

