#ifndef _IMP3_
#define _IMP3_

#define MANAGER_VERSION 1			// TODO: Define here the pluginManager version !!! (In pluginManager.h)
#define PLUGIN_NAME	 	"iMp3"		// TODO: Define here the plugin Name

#include <taglib/mpegfile.h>
#include <taglib/attachedpictureframe.h>
#include <taglib/id3v2tag.h>

#include <gst/gst.h>

#include "../gloobus-preview-interface-music.h"

#define DURATION_IS_VALID(x) (x != 0 && x != (guint64) -1)

class iMp3 : public iMusic
{
	private:
			GstElement 		*m_pipeline;
			string			m_song;
			string			m_artist;
			string			m_album;
			
			guint64			m_duration;

	
	public:
							 iMp3			( void );
							~iMp3			( void );
	virtual GdkPixbuf*		get_pixbuf  	( void );
	virtual string			get_song_artist	( void );
	virtual string			get_song_name	( void );
	virtual string			get_song_album  ( void );

	virtual	void 			play			( void );
	virtual	void			stop			( void );
	virtual double			get_position	( void );
	virtual void			seek			( gdouble value );


			void			read_names		( void );
			guint64			get_duration	( void );

	

	private:
			GdkPixbuf* 		convert_to_pixbuf	(char* ,int );

};



// ============================ Class factories======================================== //
// This is "allways the same" code, just change the plugin name in the printf and the 
// return object
extern "C" iMusic* create() {		
	printf("Creating iMp3...\n");
    return new iMp3;
}

extern "C" void destroy(iMusic* p) {
	printf("Destroying iMp3...\n");
    delete p;
}

extern "C" int getVersion(){			//To save crashes from older versions
	return MANAGER_VERSION;
}

// ============================== REGISTER ============================================ //
// Here is where we register the new plugin, what we do is to add a map with the plugin
// name and the mime file types it can load, then, the pluginManager will take care of wich
// plugin load, depending on its file type. Just add more than one file type adding this
// two lines as many times you want.
//
//	itself.filetype = "image/bmp";			// Add another extension supported
//	pluginVector.push_back(itself);			// Add filetype that plugin reads

extern "C" 
{
   class proxy {
		public:
	   	proxy()
		{
			//TODO: Add here the mime filetypes that plugin supports
			//plugin_filetype itself = {PLUGIN_NAME,EXTENSION,TYPE,PRIORITY}
			
			plugin_filetype itself = { PLUGIN_NAME, "audio/mpeg","music",1};		// Initial filetype

			factory_music[itself.name] = create;		    // Register the plugin
			factoryDestroy_music[itself.name] = destroy;	// Function for destroy this plugin class
			pluginVector.push_back(itself);					// Add filetype that plugin reads
		    
		    itself.filetype = "audio/x-vorbis+ogg";					// Add another extension supported
			pluginVector.push_back(itself);					// Add filetype that plugin reads
			
			itself.filetype = "audio/3gpp";					// Add another extension supported
			pluginVector.push_back(itself);					// Add filetype that plugin reads
			
			itself.filetype = "audio/midi";					// Add another extension supported
			pluginVector.push_back(itself);					// Add filetype that plugin reads
			
			itself.filetype = "audio/x-matroska";
			pluginVector.push_back(itself);		
			
			
	   }
 };
 proxy p;	// When we open the dll with RTLD_NOW it creates p, and in consequence, it registers the plugin 
}

#endif

