#ifndef _IPLAIN_
#define _IPLAIN_

#define MANAGER_VERSION 1				// TODO: Define here the pluginManager version !!! (In pluginManager.h)
#define PLUGIN_NAME	 	"iPlain"		// TODO: Define here the plugin Name

#include "../gloobus-preview-interface-text.h"
#include <gtksourceview/gtksourceview.h>
#include <gtksourceview/gtksourcelanguagemanager.h>

//sudo ln -s /usr/include/gtksourceview-2.0/gtksourceview/ /usr/include/gtksourceview

class iPlain : public iText
{
	public:
	virtual GtkSourceBuffer*		get_textbuf  	(void);

	private:
			

};



// ============================ Class factories======================================== //
// This is "allways the same" code, just change the plugin name in the printf and the 
// return object
extern "C" iText* create() {		
	printf("Creating iPlain...\n");
    return new iPlain;
}

extern "C" void destroy(iText* p) {
	printf("Destroying iPlain...\n");
    delete p;
}

extern "C" int getVersion(){			//To save crashes from older versions
	return MANAGER_VERSION;
}

// ============================== REGISTER ============================================ //
// Here is where we register the new plugin, what we do is to add a map with the plugin
// name and the mime file types it can load, then, the pluginManager will take care of wich
// plugin load, depending on its file type. Just add more than one file type adding this
// two lines as many times you want.
//
//	itself.filetype = "image/bmp";			// Add another extension supported
//	pluginVector.push_back(itself);			// Add filetype that plugin reads

extern "C" 
{
   class proxy {
		public:
	   	proxy()
		{
			//TODO: Add here the mime filetypes that plugin supports
			//plugin_filetype itself = {PLUGIN_NAME,EXTENSION,TYPE,PRIORITY}
			
			plugin_filetype itself = { PLUGIN_NAME, "text/plain","text",1};		// Initial filetype

			factory_text[itself.name] = create;		    // Register the plugin
			factoryDestroy_text[itself.name] = destroy;	// Function for destroy this plugin class
			pluginVector.push_back(itself);					// Add filetype that plugin reads
		    
		    itself.filetype = "text/x-c";					// Add another extension supported
			pluginVector.push_back(itself);					// Add filetype that plugin reads
		    itself.filetype = "text/x-chdr";				// Add another extension supported
			pluginVector.push_back(itself);					// Add filetype that plugin reads
		    itself.filetype = "text/x-c++src";				// Add another extension supported
			pluginVector.push_back(itself);					// Add filetype that plugin reads
		    itself.filetype = "text/x-csrc";				// Add another extension supported
			pluginVector.push_back(itself);					// Add filetype that plugin reads
			itself.filetype = "application/x-subrip";		// Add another extension supported
			pluginVector.push_back(itself);					// Add filetype that plugin reads
			itself.filetype = "text/csv";					// Add another extension supported
			pluginVector.push_back(itself);					// Add filetype that plugin reads
			itself.filetype = "application/x-php";			// Add another extension supported
			pluginVector.push_back(itself);					// Add filetype that plugin reads
			itself.filetype = "application/x-shellscript";	// Add another extension supported
			pluginVector.push_back(itself);					// Add filetype that plugin reads
			itself.filetype = "text/x-java";	// Add another extension supported
			pluginVector.push_back(itself);					// Add filetype that plugin reads
			itself.filetype = "application/javascript";	// Add another extension supported
			pluginVector.push_back(itself);					// Add filetype that plugin reads
			itself.filetype = "text/x-python";	// Add another extension supported
			pluginVector.push_back(itself);					// Add filetype that plugin reads
			itself.filetype = "text/x-log";	// Add another extension supported
			pluginVector.push_back(itself);					// Add filetype that plugin reads
			itself.filetype = "application/xml";	// Add another extension supported
			pluginVector.push_back(itself);					// Add filetype that plugin reads
	   }
 };
 proxy p;	// When we open the dll with RTLD_NOW it creates p, and in consequence, it registers the plugin 
}

#endif

